## putty 0.67

=== macosx/Makefile ===
# Makefile for putty under Mac OS X.
#
# This file was created by `mkfiles.pl' from the `Recipe' file.
# DO NOT EDIT THIS FILE DIRECTLY; edit Recipe or mkfiles.pl instead.
#
# Extra options you can set:
#
#  - COMPAT=-DAUTO_WINSOCK (Windows only)
#      Causes PuTTY to assume that <windows.h> includes its own WinSock
#      header file, so that it won't try to include <winsock.h>.
#
#  - COMPAT=-DWINSOCK_TWO (Windows only)
#      Causes the PuTTY utilities to include <winsock2.h> instead of
#      <winsock.h>, except Plink which _needs_ WinSock 2 so it already
#      does this.
#
#  - COMPAT=-DNO_SECURITY (Windows only)
#      Disables Pageant's use of <aclapi.h>, which is not available
#      with some development environments (such as older versions of
#      the Cygwin/mingw GNU toolchain). This means that Pageant
#      won't care about the local user ID of processes accessing it; a
#      version of Pageant built with this option will therefore refuse
#      to run under NT-series OSes on security grounds (although it
#      will run fine on Win95-series OSes where there is no access
#      control anyway).
#
#  - COMPAT=-DNO_MULTIMON (Windows only)
#      Disables PuTTY's use of <multimon.h>, which is not available
#      with some development environments. This means that PuTTY's
#      full-screen mode (configurable to work on Alt-Enter) will
#      not behave usefully in a multi-monitor environment.
#
#      Note that this definition is always enabled in the Cygwin
#      build, since at the time of writing this <multimon.h> is
#      known not to be available in Cygwin.
#
#  - COMPAT=-DNO_HTMLHELP (Windows only)
#      Disables PuTTY's use of <htmlhelp.h>, which is not available
#      with some development environments. The resulting binary
#      will only look for an old-style WinHelp file (.HLP/.CNT), and
#      will ignore any .CHM file.
#
#      Note that this definition is always enabled in the Cygwin
#      build, since at the time of writing this <htmlhelp.h> is
#      known not to be available in Cygwin (although you can use
#      the htmlhelp.h supplied with HTML Help Workshop).
#
#  - RCFL=-DNO_MANIFESTS (Windows only)
#      Disables inclusion of XML application manifests in the PuTTY
#      binaries. This may be necessary to build for 64-bit Windows;
#      the manifests are only included to use the XP GUI style on
#      Windows XP, and the architecture tags are a lie on 64-bit.
#
#  - COMPAT=-DNO_IPV6
#      Disables PuTTY's ability to make IPv6 connections, enabling
#      it to compile under development environments which do not
#      support IPv6 in their header files.
#
#  - COMPAT=-DNO_GSSAPI
#      Disables PuTTY's ability to use GSSAPI functions for
#      authentication and key exchange.
#
#  - COMPAT=-DSTATIC_GSSAPI
#      Causes PuTTY to try to link statically against the GSSAPI
#      library instead of the default of doing it at run time.
#
#  - COMPAT=-DMSVC4 (Windows only)
#  - RCFL=-DMSVC4
#      Makes a couple of minor changes so that PuTTY compiles using
#      MSVC 4. You will also need -DNO_SECURITY and -DNO_MULTIMON.
#
#  - COMPAT=-DNO_SECUREZEROMEMORY (Windows only)
#      Disables PuTTY's use of SecureZeroMemory(), which is missing
#      from some environments' header files.  This is enabled by
#      default in the Cygwin Makefile.
#
#  - XFLAGS=-DTELNET_DEFAULT
#      Causes PuTTY to default to the Telnet protocol (in the absence
#      of Default Settings and so on to the contrary). Normally PuTTY
#      will default to SSH.
#
#  - XFLAGS=-DDEBUG
#      Causes PuTTY to enable internal debugging.
#
#  - XFLAGS=-DUNPROTECT
#      Disable tightened ACL on PuTTY process so that e.g. debuggers
#      can attach to it.
#
#  - XFLAGS=-DMALLOC_LOG
#      Causes PuTTY to emit a file called putty_mem.log, logging every
#      memory allocation and free, so you can track memory leaks.
#
#  - XFLAGS=-DMINEFIELD (Windows only)
#      Causes PuTTY to use a custom memory allocator, similar in
#      concept to Electric Fence, in place of regular malloc(). Wastes
#      huge amounts of RAM, but should cause heap-corruption bugs to
#      show up as GPFs at the point of failure rather than appearing
#      later on as second-level damage.
#
CC = $(TOOLPATH)gcc

CFLAGS = -O2 -Wall -Werror -g -I.././ -I../charset/ -I../windows/ -I../unix/ \
		-I../macosx/
MLDFLAGS = -framework Cocoa
ULDFLAGS =

CFLAGS += -DMACOSX

all: PuTTY plink pscp psftp puttygen
PuTTY.app:
	mkdir -p $@
PuTTY.app/Contents: PuTTY.app
	mkdir -p $@
PuTTY.app/Contents/MacOS: PuTTY.app/Contents
	mkdir -p $@
PuTTY.app/Contents/Resources: PuTTY.app/Contents
	mkdir -p $@
PuTTY.app/Contents/Resources/PuTTY.icns: PuTTY.app/Contents/Resources putty.icns
	cp putty.icns $@
PuTTY.app/Contents/Info.plist: PuTTY.app/Contents/Resources info.plist
	cp info.plist $@
PuTTY: PuTTY.app/Contents/MacOS/PuTTY \
		PuTTY.app/Contents/Resources/PuTTY.icns \
		PuTTY.app/Contents/Info.plist $(PuTTY_extra)

PuTTY.app/Contents/MacOS/PuTTY: PuTTY.app/Contents/MacOS be_all_s.o \
		callback.o conf.o config.o cproxy.o dialog.o fromucs.o \
		ldisc.o ldiscucs.o localenc.o logging.o macenc.o mimeenc.o \
		minibidi.o misc.o miscucs.o osxctrls.o osxdlg.o osxmain.o \
		osxsel.o osxwin.o pgssapi.o pinger.o portfwd.o proxy.o raw.o \
		rlogin.o sbcs.o sbcsdat.o sercfg.o settings.o slookup.o \
		ssh.o sshaes.o ssharcf.o sshblowf.o sshbn.o sshcrc.o \
		sshcrcda.o sshdes.o sshdh.o sshdss.o sshgssc.o sshmd5.o \
		sshpubk.o sshrand.o sshrsa.o sshsh256.o sshsh512.o sshsha.o \
		sshshare.o sshzlib.o telnet.o terminal.o testback.o time.o \
		timing.o toucs.o tree234.o utf8.o ux_x11.o uxagentc.o \
		uxcfg.o uxgss.o uxmisc.o uxnet.o uxnoise.o uxpeer.o \
		uxprint.o uxproxy.o uxpty.o uxsel.o uxser.o uxshare.o \
		uxsignal.o uxstore.o uxucs.o version.o wcwidth.o wildcard.o \
		x11fwd.o xenc.o
	$(CC) $(MLDFLAGS) -o $@ be_all_s.o callback.o conf.o config.o \
		cproxy.o dialog.o fromucs.o ldisc.o ldiscucs.o localenc.o \
		logging.o macenc.o mimeenc.o minibidi.o misc.o miscucs.o \
		osxctrls.o osxdlg.o osxmain.o osxsel.o osxwin.o pgssapi.o \
		pinger.o portfwd.o proxy.o raw.o rlogin.o sbcs.o sbcsdat.o \
		sercfg.o settings.o slookup.o ssh.o sshaes.o ssharcf.o \
		sshblowf.o sshbn.o sshcrc.o sshcrcda.o sshdes.o sshdh.o \
		sshdss.o sshgssc.o sshmd5.o sshpubk.o sshrand.o sshrsa.o \
		sshsh256.o sshsh512.o sshsha.o sshshare.o sshzlib.o telnet.o \
		terminal.o testback.o time.o timing.o toucs.o tree234.o \
		utf8.o ux_x11.o uxagentc.o uxcfg.o uxgss.o uxmisc.o uxnet.o \
		uxnoise.o uxpeer.o uxprint.o uxproxy.o uxpty.o uxsel.o \
		uxser.o uxshare.o uxsignal.o uxstore.o uxucs.o version.o \
		wcwidth.o wildcard.o x11fwd.o xenc.o 

plink: be_all_s.o callback.o cmdline.o conf.o cproxy.o ldisc.o logging.o \
		misc.o noterm.o pgssapi.o pinger.o portfwd.o proxy.o raw.o \
		rlogin.o settings.o ssh.o sshaes.o ssharcf.o sshblowf.o \
		sshbn.o sshcrc.o sshcrcda.o sshdes.o sshdh.o sshdss.o \
		sshgssc.o sshmd5.o sshpubk.o sshrand.o sshrsa.o sshsh256.o \
		sshsh512.o sshsha.o sshshare.o sshzlib.o telnet.o time.o \
		timing.o tree234.o ux_x11.o uxagentc.o uxcons.o uxgss.o \
		uxmisc.o uxnet.o uxnoise.o uxpeer.o uxplink.o uxproxy.o \
		uxsel.o uxser.o uxshare.o uxsignal.o uxstore.o version.o \
		wildcard.o x11fwd.o
	$(CC) $(ULDFLAGS) -o $@ be_all_s.o callback.o cmdline.o conf.o \
		cproxy.o ldisc.o logging.o misc.o noterm.o pgssapi.o \
		pinger.o portfwd.o proxy.o raw.o rlogin.o settings.o ssh.o \
		sshaes.o ssharcf.o sshblowf.o sshbn.o sshcrc.o sshcrcda.o \
		sshdes.o sshdh.o sshdss.o sshgssc.o sshmd5.o sshpubk.o \
		sshrand.o sshrsa.o sshsh256.o sshsh512.o sshsha.o sshshare.o \
		sshzlib.o telnet.o time.o timing.o tree234.o ux_x11.o \
		uxagentc.o uxcons.o uxgss.o uxmisc.o uxnet.o uxnoise.o \
		uxpeer.o uxplink.o uxproxy.o uxsel.o uxser.o uxshare.o \
		uxsignal.o uxstore.o version.o wildcard.o x11fwd.o 

pscp: be_ssh.o callback.o cmdline.o conf.o cproxy.o int64.o logging.o misc.o \
		pgssapi.o pinger.o portfwd.o proxy.o pscp.o settings.o \
		sftp.o ssh.o sshaes.o ssharcf.o sshblowf.o sshbn.o sshcrc.o \
		sshcrcda.o sshdes.o sshdh.o sshdss.o sshgssc.o sshmd5.o \
		sshpubk.o sshrand.o sshrsa.o sshsh256.o sshsh512.o sshsha.o \
		sshshare.o sshzlib.o time.o timing.o tree234.o uxagentc.o \
		uxcons.o uxgss.o uxmisc.o uxnet.o uxnoise.o uxpeer.o \
		uxproxy.o uxsel.o uxsftp.o uxshare.o uxstore.o version.o \
		wildcard.o x11fwd.o
	$(CC) $(ULDFLAGS) -o $@ be_ssh.o callback.o cmdline.o conf.o \
		cproxy.o int64.o logging.o misc.o pgssapi.o pinger.o \
		portfwd.o proxy.o pscp.o settings.o sftp.o ssh.o sshaes.o \
		ssharcf.o sshblowf.o sshbn.o sshcrc.o sshcrcda.o sshdes.o \
		sshdh.o sshdss.o sshgssc.o sshmd5.o sshpubk.o sshrand.o \
		sshrsa.o sshsh256.o sshsh512.o sshsha.o sshshare.o sshzlib.o \
		time.o timing.o tree234.o uxagentc.o uxcons.o uxgss.o \
		uxmisc.o uxnet.o uxnoise.o uxpeer.o uxproxy.o uxsel.o \
		uxsftp.o uxshare.o uxstore.o version.o wildcard.o x11fwd.o 

psftp: be_ssh.o callback.o cmdline.o conf.o cproxy.o int64.o logging.o \
		misc.o pgssapi.o pinger.o portfwd.o proxy.o psftp.o \
		settings.o sftp.o ssh.o sshaes.o ssharcf.o sshblowf.o \
		sshbn.o sshcrc.o sshcrcda.o sshdes.o sshdh.o sshdss.o \
		sshgssc.o sshmd5.o sshpubk.o sshrand.o sshrsa.o sshsh256.o \
		sshsh512.o sshsha.o sshshare.o sshzlib.o time.o timing.o \
		tree234.o uxagentc.o uxcons.o uxgss.o uxmisc.o uxnet.o \
		uxnoise.o uxpeer.o uxproxy.o uxsel.o uxsftp.o uxshare.o \
		uxstore.o version.o wildcard.o x11fwd.o
	$(CC) $(ULDFLAGS) -o $@ be_ssh.o callback.o cmdline.o conf.o \
		cproxy.o int64.o logging.o misc.o pgssapi.o pinger.o \
		portfwd.o proxy.o psftp.o settings.o sftp.o ssh.o sshaes.o \
		ssharcf.o sshblowf.o sshbn.o sshcrc.o sshcrcda.o sshdes.o \
		sshdh.o sshdss.o sshgssc.o sshmd5.o sshpubk.o sshrand.o \
		sshrsa.o sshsh256.o sshsh512.o sshsha.o sshshare.o sshzlib.o \
		time.o timing.o tree234.o uxagentc.o uxcons.o uxgss.o \
		uxmisc.o uxnet.o uxnoise.o uxpeer.o uxproxy.o uxsel.o \
		uxsftp.o uxshare.o uxstore.o version.o wildcard.o x11fwd.o 

puttygen: cmdgen.o conf.o import.o misc.o notiming.o sshaes.o sshbn.o \
		sshdes.o sshdss.o sshdssg.o sshmd5.o sshprime.o sshpubk.o \
		sshrand.o sshrsa.o sshrsag.o sshsh256.o sshsh512.o sshsha.o \
		time.o tree234.o uxcons.o uxgen.o uxmisc.o uxnoise.o \
		uxstore.o version.o
	$(CC) $(ULDFLAGS) -o $@ cmdgen.o conf.o import.o misc.o notiming.o \
		sshaes.o sshbn.o sshdes.o sshdss.o sshdssg.o sshmd5.o \
		sshprime.o sshpubk.o sshrand.o sshrsa.o sshrsag.o sshsh256.o \
		sshsh512.o sshsha.o time.o tree234.o uxcons.o uxgen.o \
		uxmisc.o uxnoise.o uxstore.o version.o 

be_all_s.o: ../be_all_s.c ../putty.h ../puttyps.h ../network.h ../misc.h \
		../windows/winstuff.h ../macosx/osx.h ../unix/unix.h \
		../puttymem.h ../tree234.h ../windows/winhelp.h \
		../charset/charset.h
	$(CC) $(COMPAT) $(FWHACK) $(CFLAGS) $(XFLAGS) -c $<
be_none.o: ../be_none.c ../putty.h ../puttyps.h ../network.h ../misc.h \
		../windows/winstuff.h ../macosx/osx.h ../unix/unix.h \
		../puttymem.h ../tree234.h ../windows/winhelp.h \
		../charset/charset.h
	$(CC) $(COMPAT) $(FWHACK) $(CFLAGS) $(XFLAGS) -c $<
be_nos_s.o: ../be_nos_s.c ../putty.h ../puttyps.h ../network.h ../misc.h \
		../windows/winstuff.h ../macosx/osx.h ../unix/unix.h \
		../puttymem.h ../tree234.h ../windows/winhelp.h \
		../charset/charset.h
	$(CC) $(COMPAT) $(FWHACK) $(CFLAGS) $(XFLAGS) -c $<
be_ssh.o: ../be_ssh.c ../putty.h ../puttyps.h ../network.h ../misc.h \
		../windows/winstuff.h ../macosx/osx.h ../unix/unix.h \
		../puttymem.h ../tree234.h ../windows/winhelp.h \
		../charset/charset.h
	$(CC) $(COMPAT) $(FWHACK) $(CFLAGS) $(XFLAGS) -c $<
callback.o: ../callback.c ../putty.h ../puttyps.h ../network.h ../misc.h \
		../windows/winstuff.h ../macosx/osx.h ../unix/unix.h \
		../puttymem.h ../tree234.h ../windows/winhelp.h \
		../charset/charset.h
	$(CC) $(COMPAT) $(FWHACK) $(CFLAGS) $(XFLAGS) -c $<
cmdgen.o: ../cmdgen.c ../putty.h ../ssh.h ../puttyps.h ../network.h \

=== debian/changelog ===
putty (0.67-2) unstable; urgency=medium

  * Backport from upstream:
    - Add command-line passphrase-file options to command-line PuTTYgen.

 -- Colin Watson <cjwatson@debian.org>  Fri, 18 Mar 2016 22:32:33 +0000

putty (0.67-1) unstable; urgency=high

  * New upstream release.
    - CVE-2016-2563: Fix buffer overrun in the old-style SCP protocol
      (closes: #816921).

 -- Colin Watson <cjwatson@debian.org>  Sun, 06 Mar 2016 18:41:16 +0000

putty (0.66-4) unstable; urgency=medium

  * Use HTTPS for Vcs-* URLs, and link to cgit rather than gitweb.
  * Fix misleading-indentation and strict-aliasing warnings from GCC 6
    (closes: #811581).

 -- Colin Watson <cjwatson@debian.org>  Fri, 05 Feb 2016 13:47:21 +0000

putty (0.66-3) unstable; urgency=medium

  * Add a Homepage field.
  * Add Keywords fields to pterm.desktop and putty.desktop.
  * Build with large file support.

 -- Colin Watson <cjwatson@debian.org>  Mon, 04 Jan 2016 15:18:57 +0000

putty (0.66-2) unstable; urgency=medium

  * Fix dh_fixperms override to work properly with an
    architecture-independent-only build (closes: #806098).
  * Do much less work in architecture-independent-only builds.
  * Fix build failure on GNU/Hurd (closes: #805505).

 -- Colin Watson <cjwatson@debian.org>  Tue, 24 Nov 2015 17:10:21 +0000

putty (0.66-1) unstable; urgency=high

  * New upstream release.
    - CVE-2015-5309: Fix a potentially memory-corrupting integer overflow in
      the handling of the ECH (erase characters) control sequence in the
      terminal emulator.
  * Use dh-exec to remove the need to override dh_install.
  * Add OpenPGP signature checking configuration to watch file.

 -- Colin Watson <cjwatson@debian.org>  Sat, 07 Nov 2015 16:10:41 +0000

=== debian/rules ===
#! /usr/bin/make -f
%:
	dh $@ --with=autoreconf --parallel

ptermtmp = debian/pterm

version := $(shell dpkg-parsechangelog | grep '^Version:' | \
		   sed -e 's/.*\([0-9][0-9][0-9][0-9]-[0-9][0-9]-[0-9][0-9]\).*/\1/')

# If a snapshot, supply an explicit version. Release tarballs work it out
# for themselves.
ifeq (,$(findstring Version,$(version)))
verdef := VER=-DSNAPSHOT="$(version)"
endif

export DEB_BUILD_MAINT_OPTIONS := hardening=+all
export DEB_CPPFLAGS_MAINT_APPEND := -D_FILE_OFFSET_BITS=64

autoreconf:
	./mkfiles.pl
	autoreconf -fi
	rm -rf autom4te.cache

override_dh_autoreconf-arch:
	dh_autoreconf debian/rules -- autoreconf

override_dh_autoreconf-indep:

override_dh_auto_configure-indep:

override_dh_auto_build-arch:
	dh_auto_build -- $(verdef)
	-$(MAKE) -C icons cicons pngs

override_dh_auto_build-indep:

override_dh_auto_test-indep:

override_dh_auto_clean:
	dh_auto_clean
	$(MAKE) -C icons clean

override_dh_compress:
	dh_compress -X.py

override_dh_fixperms-arch:
	dh_fixperms
	chgrp utmp $(ptermtmp)/usr/bin/pterm
	chmod g+s $(ptermtmp)/usr/bin/pterm

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.gpg/ \
http://the.earth.li/~sgtatham/putty/latest/putty-(.*)\.tar\.gz

## putty 0.70

=== doc/Makefile ===
all: man index.html

# Decide on the versionid policy.
#
# If the user has passed in $(VERSION) on the command line (`make
# VERSION="Release 0.56"'), we use that as an explicit version string.
# Otherwise, we use `svnversion' to examine the checked-out
# documentation source, and if that returns a single revision number
# then we invent a version string reflecting just that number. Failing
# _that_, we resort to versionids.but which gives 'version
# unavailable'.
#
# So here, we define VERSION using svnversion if it isn't already
# defined ...
ifndef VERSION
SVNVERSION=$(shell test -d .svn && svnversion .)
BADCHARS=$(findstring :,$(SVNVERSION))$(findstring S,$(SVNVERSION))
ifeq ($(BADCHARS),)
ifneq ($(SVNVERSION),)
ifneq ($(SVNVERSION),exported)
VERSION=Built from revision $(patsubst M,,$(SVNVERSION))
endif
endif
endif
endif
# ... and now, we condition our build behaviour on whether or not
# VERSION _is_ defined.
ifdef VERSION
VERSIONIDS=vstr
vstr.but: FORCE
	printf '\\versionid $(VERSION)\n' > vstr.but
FORCE:;
else
VERSIONIDS=vids
endif

CHAPTERS := $(SITE) copy blurb intro gs using config pscp psftp plink
CHAPTERS += pubkey pageant errors faq feedback licence udp pgpkeys sshnames
CHAPTERS += index $(VERSIONIDS)

INPUTS = $(patsubst %,%.but,$(CHAPTERS))

# This is temporary. Hack it locally or something.
HALIBUT = halibut

index.html: $(INPUTS)
	$(HALIBUT) --text --html --winhelp --chm $(INPUTS)

# During formal builds it's useful to be able to build these ones alone.
putty.hlp: $(INPUTS)
	$(HALIBUT) --winhelp $(INPUTS)
putty.chm: $(INPUTS)
	$(HALIBUT) --chm $(INPUTS)

putty.info: $(INPUTS)
	$(HALIBUT) --info $(INPUTS)

MKMAN = $(HALIBUT) --man=$@ mancfg.but $<
MANPAGES = putty.1 puttygen.1 plink.1 pscp.1 psftp.1 puttytel.1 pterm.1 \
           pageant.1
man: $(MANPAGES)

putty.1: man-putt.but mancfg.but; $(MKMAN)
puttygen.1: man-pg.but mancfg.but; $(MKMAN)
plink.1: man-pl.but mancfg.but; $(MKMAN)
pscp.1: man-pscp.but mancfg.but; $(MKMAN)
psftp.1: man-psft.but mancfg.but; $(MKMAN)
puttytel.1: man-ptel.but mancfg.but; $(MKMAN)
pterm.1: man-pter.but mancfg.but; $(MKMAN)
pageant.1: man-pag.but mancfg.but; $(MKMAN)

mostlyclean:
	rm -f *.html *.txt *.hlp *.cnt *.1 *.info vstr.but *.hh[pck]
clean: mostlyclean
	rm -f *.chm

=== debian/changelog ===
putty (0.70-4) unstable; urgency=medium

  * Cherry-pick from upstream:
    - Ignore spurious configure_area events, which caused a lot of
      flickering on GTK+ 3.

 -- Colin Watson <cjwatson@debian.org>  Thu, 05 Apr 2018 00:27:48 +0100

putty (0.70-3) unstable; urgency=medium

  * Use GDK_BACKEND x11 when built with X support (thanks, Andreas
    Henriksson; closes: #861603).

 -- Colin Watson <cjwatson@debian.org>  Tue, 03 Apr 2018 02:03:31 +0100

putty (0.70-2) unstable; urgency=medium

  * Move VCS to salsa.debian.org.
  * Cherry-pick from upstream:
    - Use gdk_display_beep() in place of obsolete gdk_beep() (closes:
      #891519).

 -- Colin Watson <cjwatson@debian.org>  Sun, 04 Mar 2018 18:20:39 +0000

putty (0.70-1) unstable; urgency=medium

  * New upstream release.

 -- Colin Watson <cjwatson@debian.org>  Sat, 08 Jul 2017 13:19:23 +0100

putty (0.69-2) unstable; urgency=medium

  * Update Homepage and debian/copyright download URL to use HTTPS.
  * Upload to unstable.

 -- Colin Watson <cjwatson@debian.org>  Sun, 18 Jun 2017 12:20:31 +0100

putty (0.69-1) experimental; urgency=medium

  * New upstream release.

 -- Colin Watson <cjwatson@debian.org>  Sat, 29 Apr 2017 13:14:57 +0100

putty (0.68-2) experimental; urgency=medium

  * Move pageant from putty-tools to putty, since it depends on GTK+
    (thanks, Dr. Markus Waldeck).

 -- Colin Watson <cjwatson@debian.org>  Sun, 02 Apr 2017 17:26:23 +0100

putty (0.68-1) experimental; urgency=medium

  * New upstream release.
    - Supports elliptic-curve cryptography for host keys, user
      authentication keys, and key exchange (closes: #854287).
    - Ported to GTK+ 3.
  * Use HTTPS URL in debian/watch.
  * Install Pageant, which is now ported to Unix.
  * Cherry-pick a set of upstream patches to get things working with GTK+
    3.22:
    - Handle GTK 3.22's deprecation of gdk_cairo_create().
    - Handle deprecation of gtk_menu_popup.
    - Use CSS to set window backgrounds with GTK+ 3.
    - Handle deprecation of gdk_screen_{width,height}.
    - Replace deprecated gtk_window_set_wmclass with raw Xlib.
    - Change Cairo image surface type from RGB24 to ARGB32.
  * Update download URL in debian/copyright (thanks, Dr. Markus Waldeck).

 -- Colin Watson <cjwatson@debian.org>  Sun, 02 Apr 2017 00:16:29 +0100

putty (0.67-3) unstable; urgency=high

  * CVE-2017-6542: Sanity-check message length fields in CHAN_AGENT input
    (thanks, Simon Tatham; closes: #857642).

 -- Colin Watson <cjwatson@debian.org>  Wed, 22 Mar 2017 14:42:13 +0000

=== debian/control ===
Source: putty
Section: net
Priority: optional
Maintainer: Colin Watson <cjwatson@debian.org>
Standards-Version: 3.5.9
Build-Depends: dpkg-dev (>= 1.15.7~), debhelper (>= 9~), dh-autoreconf, dh-exec, pkg-config, libgtk-3-dev, x11proto-core-dev, libx11-dev, imagemagick, python
Homepage: https://www.chiark.greenend.org.uk/~sgtatham/putty/
Vcs-Git: https://salsa.debian.org/ssh-team/putty
Vcs-Browser: https://salsa.debian.org/ssh-team/putty

Package: pterm
Section: x11
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: putty-doc
Provides: x-terminal-emulator
Description: PuTTY terminal emulator
 This is an X terminal emulator based on the popular Windows SSH client,
 PuTTY. It supports xterm escape sequences, plus some Linux console
 sequences for colour palette configuration and some DECterm sequences for
 title bar control, and with an appropriate font it supports the UTF-8
 encoding of Unicode. It also has some nifty features like rectangular
 selection and NetHack keypad mode.

Package: putty
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, putty-tools
Suggests: putty-doc
Breaks: putty-tools (<< 0.68-2~)
Replaces: putty-tools (<< 0.68-2~)
Description: Telnet/SSH client for X
 This is the Unix port of the popular Windows SSH client, PuTTY. It supports
 flexible terminal setup, mid-session reconfiguration using Ctrl-rightclick,
 multiple X11 authentication protocols, and various other interesting things
 not provided by ssh in an xterm.
 .
 Pageant is an SSH authentication agent, and a tool for communicating with
 an already-running agent.

Package: putty-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: putty-doc
Description: command-line tools for SSH, SCP, and SFTP
 This package provides four command-line tools from the PuTTY suite that
 allow various kinds of secure interaction with remote systems.
 .
 Plink (PuTTY Link) connects to a remote system via SSH, Telnet, or rlogin,
 and either starts an interactive session or runs a batch process. It
 supports the usual SSH features like port forwarding, X11 forwarding,
 SOCKS, and compression.
 .
 PSCP (PuTTY Secure Copy) transfers files securely between systems using an
 SSH connection. It works with both SSH protocol 1 and protocol 2.
 .
 PSFTP (PuTTY SFTP client) transfers files securely between systems using
 the SSH file transfer protocol, which is specific to SSH protocol 2. In
 interactive mode its interface is much like the traditional Unix FTP
 client, although it can also operate in batch mode.
 .
 PuTTYgen generates SSH public and private key pairs in any of a number of
 formats, including those usable by PuTTY, OpenSSH, and ssh.com.
 .
 All these utilities can make use of PuTTY's saved sessions where
 appropriate.

Package: putty-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: PuTTY HTML documentation
 Full HTML documentation for the PuTTY suite of programs (PuTTY, pterm,
 Plink, PSCP, PSFTP, and PuTTYgen).

=== debian/rules ===
--- 
+++ 
@@ -3,15 +3,6 @@
 	dh $@ --with=autoreconf --parallel
 
 ptermtmp = debian/pterm
-
-version := $(shell dpkg-parsechangelog | grep '^Version:' | \
-		   sed -e 's/.*\([0-9][0-9][0-9][0-9]-[0-9][0-9]-[0-9][0-9]\).*/\1/')
-
-# If a snapshot, supply an explicit version. Release tarballs work it out
-# for themselves.
-ifeq (,$(findstring Version,$(version)))
-verdef := VER=-DSNAPSHOT="$(version)"
-endif
 
 export DEB_BUILD_MAINT_OPTIONS := hardening=+all
 export DEB_CPPFLAGS_MAINT_APPEND := -D_FILE_OFFSET_BITS=64
@@ -29,7 +20,7 @@
 override_dh_auto_configure-indep:
 
 override_dh_auto_build-arch:
-	dh_auto_build -- $(verdef)
+	dh_auto_build
 	-$(MAKE) -C icons cicons pngs
 
 override_dh_auto_build-indep:

## putty 0.72

=== debian/changelog ===
putty (0.72-1) unstable; urgency=medium

  * New upstream release.
  * Explicitly build-depend on python3, for test/cryptsuite.py.

 -- Colin Watson <cjwatson@debian.org>  Tue, 23 Jul 2019 10:49:47 +0100

putty (0.71-1) experimental; urgency=medium

  * Add new upstream release signing key to debian/upstream/signing-key.asc
    (see https://www.chiark.greenend.org.uk/~sgtatham/putty/keys.html).
  * New upstream release (see
    https://www.chiark.greenend.org.uk/~sgtatham/putty/changes.html).
    - Make "putty user@host" work (closes: #509194).

 -- Colin Watson <cjwatson@debian.org>  Wed, 20 Mar 2019 13:11:14 +0000

putty (0.70-6) unstable; urgency=high

  * Apply security patch series from upstream:
    - New facility for removing pending toplevel callbacks.
    - Fix one-byte buffer overrun in random_add_noise().
    - uxnet: clean up callbacks when closing a NetSocket.
    - sk_tcp_close: fix memory leak of output bufchain.
    - Fix handling of bad RSA key with n=p=q=0.
    - Sanity-check the 'Public-Lines' field in ppk files.
    - Introduce an enum of the uxsel / select_result flags.
    - Switch to using poll(2) in place of select(2).
    - RSA kex: enforce the minimum key length.
    - Fix crash on ESC#6 + combining chars + GTK + odd-width terminal.
    - Limit the number of combining chars per terminal cell.
    - minibidi: fix read past end of line in rule W5.
    - Fix crash printing a width-2 char in a width-1 terminal.

 -- Colin Watson <cjwatson@debian.org>  Sun, 17 Mar 2019 09:37:02 +0000

putty (0.70-5) unstable; urgency=medium

  [ Colin Watson ]
  * Mark all binary packages Multi-Arch: foreign.
  * Configure with --disable-git-commit to avoid a build failure due to
    trying to redefine SOURCE_COMMIT when building from the Debian git tree.
  * Cherry-pick from upstream:
    - Remove a fixed-size buffer in pscp.c (closes: #911955).
    - Remove a fixed-size buffer in cmdgen.c.
    - Stop using deprecated gtk_container_set_focus_chain().

  [ Niels Thykier ]
  * Declare the explicit requirement for (fake)root.

 -- Colin Watson <cjwatson@debian.org>  Sun, 28 Oct 2018 18:07:45 +0000

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,11 @@
 Priority: optional
 Maintainer: Colin Watson <cjwatson@debian.org>
 Standards-Version: 3.5.9
-Build-Depends: dpkg-dev (>= 1.15.7~), debhelper (>= 9~), dh-autoreconf, dh-exec, pkg-config, libgtk-3-dev, x11proto-core-dev, libx11-dev, imagemagick, python
+Build-Depends: dpkg-dev (>= 1.15.7~), debhelper (>= 9~), dh-autoreconf, dh-exec, pkg-config, libgtk-3-dev, x11proto-core-dev, libx11-dev, imagemagick, python, python3
 Homepage: https://www.chiark.greenend.org.uk/~sgtatham/putty/
-Vcs-Git: https://salsa.debian.org/ssh-team/putty
+Vcs-Git: https://salsa.debian.org/ssh-team/putty.git
 Vcs-Browser: https://salsa.debian.org/ssh-team/putty
+Rules-Requires-Root: binary-targets
 
 Package: pterm
 Section: x11
@@ -14,6 +15,7 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Suggests: putty-doc
 Provides: x-terminal-emulator
+Multi-Arch: foreign
 Description: PuTTY terminal emulator
  This is an X terminal emulator based on the popular Windows SSH client,
  PuTTY. It supports xterm escape sequences, plus some Linux console
@@ -28,6 +30,7 @@
 Suggests: putty-doc
 Breaks: putty-tools (<< 0.68-2~)
 Replaces: putty-tools (<< 0.68-2~)
+Multi-Arch: foreign
 Description: Telnet/SSH client for X
  This is the Unix port of the popular Windows SSH client, PuTTY. It supports
  flexible terminal setup, mid-session reconfiguration using Ctrl-rightclick,
@@ -41,6 +44,7 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Suggests: putty-doc
+Multi-Arch: foreign
 Description: command-line tools for SSH, SCP, and SFTP
  This package provides four command-line tools from the PuTTY suite that
  allow various kinds of secure interaction with remote systems.
@@ -68,6 +72,7 @@
 Section: doc
 Architecture: all
 Depends: ${misc:Depends}
+Multi-Arch: foreign
 Description: PuTTY HTML documentation
  Full HTML documentation for the PuTTY suite of programs (PuTTY, pterm,
  Plink, PSCP, PSFTP, and PuTTYgen).

## putty 0.73

=== debian/changelog ===
putty (0.73-2) unstable; urgency=medium

  * Cherry-pick from upstream:
    - gtkfont: use PANGO_PIXELS_CEIL to work out font metrics (fixes
      rendering regression at some font sizes with Pango 1.44).

 -- Colin Watson <cjwatson@debian.org>  Sun, 05 Apr 2020 12:22:42 +0100

putty (0.73-1) unstable; urgency=medium

  * New upstream release.

 -- Colin Watson <cjwatson@debian.org>  Sun, 29 Sep 2019 17:10:38 +0100

putty (0.72-2) unstable; urgency=medium

  * Use debhelper-compat instead of debian/compat.
  * Port mkicon.py to Python 3 and drop build-dependency on python (closes:
    #937380).

 -- Colin Watson <cjwatson@debian.org>  Sat, 31 Aug 2019 21:46:04 +0100

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.gpg/ \
https://the.earth.li/~sgtatham/putty/latest/putty-(.*)\.tar\.gz

## putty 0.74

=== doc/Makefile ===
--- 
+++ 
@@ -44,13 +44,15 @@
 HALIBUT = halibut
 
 index.html: $(INPUTS)
-	$(HALIBUT) --text --html --winhelp --chm $(INPUTS)
+	$(HALIBUT) --text --html --chm $(INPUTS)
 
-# During formal builds it's useful to be able to build these ones alone.
+# During formal builds it's useful to be able to build this one alone.
+putty.chm: $(INPUTS)
+	$(HALIBUT) --chm $(INPUTS)
+
+# We don't ship this any more.
 putty.hlp: $(INPUTS)
 	$(HALIBUT) --winhelp $(INPUTS)
-putty.chm: $(INPUTS)
-	$(HALIBUT) --chm $(INPUTS)
 
 putty.info: $(INPUTS)
 	$(HALIBUT) --info $(INPUTS)

=== test/sclog/CMakeLists.txt ===
# CMake script for the 'sclog' DynamoRIO instrumentation system that
# goes with the PuTTY test binary 'testsc'. For build instructions see
# the comment at the top of testsc.c.

cmake_minimum_required(VERSION 3.5)

find_package(DynamoRIO)
if (NOT DynamoRIO_FOUND)
  message(FATAL_ERROR "DynamoRIO not found")
endif()

add_library(sclog SHARED sclog.c)
configure_DynamoRIO_client(sclog)
foreach(extension drmgr drsyms drreg drutil drwrap)
  use_DynamoRIO_extension(sclog ${extension})
endforeach()

=== debian/changelog ===
putty (0.74-1+deb11u2) bullseye; urgency=medium

  * Non-maintainer upload.
  * Cherry-pick from upstream:
    - Refactor the ssh_hash vtable.
    - Add an extra HMAC constructor function.
    - Fix CVE-2024-31497: biased ECDSA nonce generation allows an attacker
      to recover a user's NIST P-521 secret key via a quick attack in
      approximately 60 signatures. In other words, an adversary
      may already have enough signature information to compromise a victim's
      private key, even if there is no further use of vulnerable PuTTY
      versions.

 -- Bastien Roucariès <rouca@debian.org>  Tue, 16 Jul 2024 10:13:59 +0000

putty (0.74-1+deb11u1) bullseye-security; urgency=medium

  * Cherry-pick from upstream:
    - CVE-2021-36367: New option to reject 'trivial' success of userauth
      (closes: #990901).
    - New macro PTRLEN_DECL_LITERAL.
    - Extra utility function add_to_commasep_pl.
    - CVE-2023-48795: Support OpenSSH's new strict kex feature (thanks to
      Simon Tatham for backporting assistance).
    Note that this does _not_ include upstream's added UI warning for
    servers vulnerable to Terrapin, which was too difficult to backport to
    this version.

 -- Colin Watson <cjwatson@debian.org>  Fri, 22 Dec 2023 17:36:21 +0000

putty (0.74-1) unstable; urgency=medium

  * New upstream release.
    - SECURITY: Key list from agent used after free if server rejects
      signature after PK_OK.
    - CVE-2020-14002: Dynamic host key policy leaks information about known
      host keys.

 -- Colin Watson <cjwatson@debian.org>  Sat, 27 Jun 2020 13:43:16 +0100

putty (0.73-3) unstable; urgency=medium

  * Cherry-pick from upstream:
    - pty_backend_create: set up SIGCHLD handler earlier (closes: #959396).

 -- Colin Watson <cjwatson@debian.org>  Fri, 08 May 2020 15:52:01 +0100

=== debian/rules ===
--- 
+++ 
@@ -16,6 +16,9 @@
 	dh_autoreconf debian/rules -- autoreconf
 
 override_dh_autoreconf-indep:
+
+override_dh_auto_configure-arch:
+	dh_auto_configure -- --disable-git-commit
 
 override_dh_auto_configure-indep:

## putty 0.75

=== debian/changelog ===
putty (0.75-3) unstable; urgency=medium

  * Cherry-pick from upstream:
    - CVE-2021-36367: New option to reject 'trivial' success of userauth
      (closes: #990901).

 -- Colin Watson <cjwatson@debian.org>  Sun, 11 Jul 2021 00:35:09 +0100

putty (0.75-2) unstable; urgency=medium

  * Add psusan to putty-tools.

 -- Colin Watson <cjwatson@debian.org>  Wed, 02 Jun 2021 15:03:48 +0100

putty (0.75-1) unstable; urgency=medium

  * New upstream release.

 -- Colin Watson <cjwatson@debian.org>  Sun, 09 May 2021 11:24:32 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Colin Watson <cjwatson@debian.org>
 Standards-Version: 3.5.9
-Build-Depends: dpkg-dev (>= 1.15.7~), debhelper (>= 9~), dh-autoreconf, dh-exec, pkg-config, libgtk-3-dev, x11proto-core-dev, libx11-dev, imagemagick, python, python3
+Build-Depends: dpkg-dev (>= 1.15.7~), debhelper-compat (= 9), dh-autoreconf, dh-exec, pkg-config, libgtk-3-dev, x11proto-core-dev, libx11-dev, imagemagick, python3
 Homepage: https://www.chiark.greenend.org.uk/~sgtatham/putty/
 Vcs-Git: https://salsa.debian.org/ssh-team/putty.git
 Vcs-Browser: https://salsa.debian.org/ssh-team/putty
@@ -46,7 +46,7 @@
 Suggests: putty-doc
 Multi-Arch: foreign
 Description: command-line tools for SSH, SCP, and SFTP
- This package provides four command-line tools from the PuTTY suite that
+ This package provides several command-line tools from the PuTTY suite that
  allow various kinds of secure interaction with remote systems.
  .
  Plink (PuTTY Link) connects to a remote system via SSH, Telnet, or rlogin,
@@ -65,8 +65,11 @@
  PuTTYgen generates SSH public and private key pairs in any of a number of
  formats, including those usable by PuTTY, OpenSSH, and ssh.com.
  .
- All these utilities can make use of PuTTY's saved sessions where
- appropriate.
+ psusan (pseudo-SSH for untappable, separately authenticated networks) is a
+ server program that behaves like the innermost "connection" layer of an SSH
+ session, without the two outer security layers of encryption and
+ authentication. It can be used to add SSH-like amenities to channels where
+ you were already prepared to run a bare shell session.
 
 Package: putty-doc
 Section: doc

## putty 0.76

=== doc/Makefile ===
--- 
+++ 
@@ -35,7 +35,8 @@
 endif
 
 CHAPTERS := $(SITE) copy blurb intro gs using config pscp psftp plink
-CHAPTERS += pubkey pageant errors faq feedback licence udp pgpkeys sshnames
+CHAPTERS += pubkey pageant errors faq feedback pubkeyfmt licence udp
+CHAPTERS += pgpkeys sshnames
 CHAPTERS += index $(VERSIONIDS)
 
 INPUTS = $(patsubst %,%.but,$(CHAPTERS))
@@ -59,17 +60,19 @@
 
 MKMAN = $(HALIBUT) --man=$@ mancfg.but $<
 MANPAGES = putty.1 puttygen.1 plink.1 pscp.1 psftp.1 puttytel.1 pterm.1 \
-           pageant.1
+           pageant.1 psocks.1 psusan.1
 man: $(MANPAGES)
 
-putty.1: man-putt.but mancfg.but; $(MKMAN)
-puttygen.1: man-pg.but mancfg.but; $(MKMAN)
-plink.1: man-pl.but mancfg.but; $(MKMAN)
+putty.1: man-putty.but mancfg.but; $(MKMAN)
+puttygen.1: man-puttygen.but mancfg.but; $(MKMAN)
+plink.1: man-plink.but mancfg.but; $(MKMAN)
 pscp.1: man-pscp.but mancfg.but; $(MKMAN)
-psftp.1: man-psft.but mancfg.but; $(MKMAN)
-puttytel.1: man-ptel.but mancfg.but; $(MKMAN)
-pterm.1: man-pter.but mancfg.but; $(MKMAN)
-pageant.1: man-pag.but mancfg.but; $(MKMAN)
+psftp.1: man-psftp.but mancfg.but; $(MKMAN)
+puttytel.1: man-puttytel.but mancfg.but; $(MKMAN)
+pterm.1: man-pterm.but mancfg.but; $(MKMAN)
+pageant.1: man-pageant.but mancfg.but; $(MKMAN)
+psocks.1: man-psocks.but mancfg.but; $(MKMAN)
+psusan.1: man-psusan.but mancfg.but; $(MKMAN)
 
 mostlyclean:
 	rm -f *.html *.txt *.hlp *.cnt *.1 *.info vstr.but *.hh[pck]

=== icons/Makefile ===
# Makefile for the PuTTY icon suite.

ICONS = putty puttycfg puttygen pscp pageant pterm ptermcfg puttyins
SIZES = 16 32 48 128

MODE = # override to -it on command line for opaque testing

PAMS = $(foreach I,$(ICONS),$(foreach S,$(SIZES),$(I)-$(S).pam))
MONOPAMS = $(foreach I,$(ICONS),$(foreach S,$(SIZES),$(I)-$(S)-mono.pam))
TRUEPAMS = $(foreach I,$(ICONS),$(foreach S,$(SIZES),$(I)-$(S)-true.pam))

PNGS = $(patsubst %.pam,%.png,$(PAMS))
MONOPNGS = $(patsubst %.pam,%.png,$(MONOPAMS))
TRUEPNGS = $(patsubst %.pam,%.png,$(TRUEPAMS))

ICOS = putty.ico puttygen.ico pscp.ico pageant.ico pageants.ico puttycfg.ico \
       puttyins.ico
ICNS = PuTTY.icns Pterm.icns
CICONS = xpmputty.c xpmpucfg.c xpmpterm.c xpmptcfg.c

base: icos cicons

all: pngs monopngs base icns # truepngs currently disabled by default

pngs: $(PNGS)
monopngs: $(MONOPNGS)
truepngs: $(TRUEPNGS)

icos: $(ICOS)
icns: $(ICNS)
cicons: $(CICONS)

install: icos cicons
	cp $(ICOS) ../windows
	cp $(CICONS) ../unix

$(PAMS): %.pam: mkicon.py
	./mkicon.py $(MODE) $(join $(subst -, ,$(basename $@)),_icon) $@

$(PNGS) $(MONOPNGS) $(TRUEPNGS): %.png: %.pam
	convert $< $@

$(MONOPAMS): %.pam: mkicon.py
	./mkicon.py -2 $(MODE) $(join $(subst -, ,$(subst -mono,,$(basename $@))),_icon) $@

$(TRUEPAMS): %.pam: mkicon.py
	./mkicon.py -T $(MODE) $(join $(subst -, ,$(subst -true,,$(basename $@))),_icon) $@

putty.ico: putty-16.png putty-32.png putty-48.png \
           putty-16-mono.png putty-32-mono.png putty-48-mono.png
	./icon.pl -4 $(filter-out %-mono.png, $^) -1 $(filter %-mono.png, $^) > $@

puttycfg.ico: puttycfg-16.png puttycfg-32.png puttycfg-48.png \
              puttycfg-16-mono.png puttycfg-32-mono.png puttycfg-48-mono.png
	./icon.pl -4 $(filter-out %-mono.png, $^) -1 $(filter %-mono.png, $^) > $@

puttygen.ico: puttygen-16.png puttygen-32.png puttygen-48.png \
              puttygen-16-mono.png puttygen-32-mono.png puttygen-48-mono.png
	./icon.pl -4 $(filter-out %-mono.png, $^) -1 $(filter %-mono.png, $^) > $@

pageant.ico: pageant-16.png pageant-32.png pageant-48.png \
             pageant-16-mono.png pageant-32-mono.png pageant-48-mono.png
	./icon.pl -4 $(filter-out %-mono.png, $^) -1 $(filter %-mono.png, $^) > $@

pageants.ico: pageant-16.png pageant-16-mono.png
	./icon.pl -4 $(filter-out %-mono.png, $^) -1 $(filter %-mono.png, $^) > $@

pscp.ico: pscp-16.png pscp-32.png pscp-48.png \
          pscp-16-mono.png pscp-32-mono.png pscp-48-mono.png
	./icon.pl -4 $(filter-out %-mono.png, $^) -1 $(filter %-mono.png, $^) > $@

# Because the installer icon makes heavy use of brown when drawing
# the cardboard box, it's worth having 8-bit versions of it in
# addition to the 4- and 1-bit ones.
puttyins.ico: puttyins-16.png puttyins-32.png puttyins-48.png \
              puttyins-16-mono.png puttyins-32-mono.png \
              puttyins-48-mono.png \
              puttyins-16-true.png puttyins-32-true.png \
              puttyins-48-true.png
	./icon.pl -8 $(filter %-true.png, $^) \
                  -4 $(filter-out %-true.png, $(filter-out %-mono.png, $^)) \
                  -1 $(filter %-mono.png, $^) > $@

# Icon for the website. (This isn't linked into "make all".)
website.ico: putty-16.png
	./icon.pl -4 $^ >$@

xpmputty.c: putty-16.png putty-32.png putty-48.png
	./cicon.pl main_icon $^ > $@

xpmpucfg.c: puttycfg-16.png puttycfg-32.png puttycfg-48.png
	./cicon.pl cfg_icon $^ > $@

xpmpterm.c: pterm-16.png pterm-32.png pterm-48.png
	./cicon.pl main_icon $^ > $@

xpmptcfg.c: ptermcfg-16.png ptermcfg-32.png ptermcfg-48.png
	./cicon.pl cfg_icon $^ > $@

PuTTY.icns: putty-16-mono.pam putty-16.pam \
	    putty-32-mono.pam putty-32.pam \
	    putty-48-mono.pam putty-48.pam \
	    putty-128.pam
	./macicon.py mono:putty-16-mono.pam colour:putty-16.pam \
	             mono:putty-32-mono.pam colour:putty-32.pam \
	             mono:putty-48-mono.pam colour:putty-48.pam \
	                                    colour:putty-128.pam \
		output:$@

Pterm.icns: pterm-16-mono.pam pterm-16.pam \
	    pterm-32-mono.pam pterm-32.pam \
	    pterm-48-mono.pam pterm-48.pam \
	    pterm-128.pam
	./macicon.py mono:pterm-16-mono.pam colour:pterm-16.pam \
	             mono:pterm-32-mono.pam colour:pterm-32.pam \
	             mono:pterm-48-mono.pam colour:pterm-48.pam \
	                                    colour:pterm-128.pam \
		output:$@

clean:
	rm -f *.pam *.png *.ico *.icns *.c

=== debian/changelog ===
putty (0.76-2) unstable; urgency=medium

  * Upgrade to debhelper v13.
  * Build documentation from source using halibut (fixes bug where man page
    patches in 0.76-1 were ineffective).

 -- Colin Watson <cjwatson@debian.org>  Tue, 21 Dec 2021 00:48:30 +0000

putty (0.76-1) unstable; urgency=medium

  * New upstream release.
  * Cherry-pick from upstream:
    - psusan manpage: add a PATH to the UML example (closes: #991960).
    - Bug workaround to delay sending our SSH greeting (see #991958).

 -- Colin Watson <cjwatson@debian.org>  Mon, 16 Aug 2021 00:29:11 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,16 @@
 Priority: optional
 Maintainer: Colin Watson <cjwatson@debian.org>
 Standards-Version: 3.5.9
-Build-Depends: dpkg-dev (>= 1.15.7~), debhelper-compat (= 9), dh-autoreconf, dh-exec, pkg-config, libgtk-3-dev, x11proto-core-dev, libx11-dev, imagemagick, python3
+Build-Depends: debhelper-compat (= 13),
+               dh-exec,
+               dpkg-dev (>= 1.15.7~),
+               halibut,
+               imagemagick,
+               libgtk-3-dev,
+               libx11-dev,
+               pkg-config,
+               python3,
+               x11proto-core-dev,
 Homepage: https://www.chiark.greenend.org.uk/~sgtatham/putty/
 Vcs-Git: https://salsa.debian.org/ssh-team/putty.git
 Vcs-Browser: https://salsa.debian.org/ssh-team/putty
@@ -12,9 +21,10 @@
 Package: pterm
 Section: x11
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Suggests: putty-doc
-Provides: x-terminal-emulator
+Depends: ${misc:Depends},
+         ${shlibs:Depends},
+Suggests: putty-doc,
+Provides: x-terminal-emulator,
 Multi-Arch: foreign
 Description: PuTTY terminal emulator
  This is an X terminal emulator based on the popular Windows SSH client,
@@ -26,10 +36,12 @@
 
 Package: putty
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, putty-tools
-Suggests: putty-doc
-Breaks: putty-tools (<< 0.68-2~)
-Replaces: putty-tools (<< 0.68-2~)
+Depends: putty-tools,
+         ${misc:Depends},
+         ${shlibs:Depends},
+Suggests: putty-doc,
+Breaks: putty-tools (<< 0.68-2~),
+Replaces: putty-tools (<< 0.68-2~),
 Multi-Arch: foreign
 Description: Telnet/SSH client for X
  This is the Unix port of the popular Windows SSH client, PuTTY. It supports
@@ -42,8 +54,9 @@
 
 Package: putty-tools
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Suggests: putty-doc
+Depends: ${misc:Depends},
+         ${shlibs:Depends},
+Suggests: putty-doc,
 Multi-Arch: foreign
 Description: command-line tools for SSH, SCP, and SFTP
  This package provides several command-line tools from the PuTTY suite that
@@ -74,7 +87,7 @@
 Package: putty-doc
 Section: doc
 Architecture: all
-Depends: ${misc:Depends}
+Depends: ${misc:Depends},
 Multi-Arch: foreign
 Description: PuTTY HTML documentation
  Full HTML documentation for the PuTTY suite of programs (PuTTY, pterm,

=== debian/rules ===
--- 
+++ 
@@ -1,11 +1,13 @@
 #! /usr/bin/make -f
 %:
-	dh $@ --with=autoreconf --parallel
+	dh $@
 
 ptermtmp = debian/pterm
 
 export DEB_BUILD_MAINT_OPTIONS := hardening=+all
 export DEB_CPPFLAGS_MAINT_APPEND := -D_FILE_OFFSET_BITS=64
+
+include /usr/share/dpkg/default.mk
 
 autoreconf:
 	./mkfiles.pl
@@ -24,6 +26,8 @@
 
 override_dh_auto_build-arch:
 	dh_auto_build
+	$(MAKE) -C doc clean all \
+		VERSION='$(DEB_VENDOR) PuTTY release $(DEB_VERSION)'
 	-$(MAKE) -C icons cicons pngs
 
 override_dh_auto_build-indep:
@@ -34,6 +38,10 @@
 	dh_auto_clean
 	$(MAKE) -C icons clean
 
+override_dh_installdocs:
+	dh_installdocs -Nputty-doc
+	dh_installdocs -pputty-doc --doc-main-package=putty-doc
+
 override_dh_compress:
 	dh_compress -X.py

## putty 0.77

=== debian/changelog ===
putty (0.77-1) unstable; urgency=medium

  * Use dh_installalternatives.
  * Simplify some debhelper overrides slightly.
  * Update upstream release signing keys (see
    https://www.chiark.greenend.org.uk/~sgtatham/putty/keys.html).
  * New upstream release.
  * Rework packaging somewhat to handle upstream's switch to CMake.

 -- Colin Watson <cjwatson@debian.org>  Tue, 31 May 2022 10:28:05 +0100

=== debian/control ===
--- 
+++ 
@@ -3,16 +3,18 @@
 Priority: optional
 Maintainer: Colin Watson <cjwatson@debian.org>
 Standards-Version: 3.5.9
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: cmake,
+               debhelper (>= 13.1),
+               debhelper-compat (= 13),
                dh-exec,
                dpkg-dev (>= 1.15.7~),
-               halibut,
-               imagemagick,
-               libgtk-3-dev,
-               libx11-dev,
-               pkg-config,
-               python3,
-               x11proto-core-dev,
+Build-Depends-Arch: imagemagick,
+                    libgtk-3-dev,
+                    libx11-dev,
+                    pkg-config,
+                    python3,
+                    x11proto-core-dev,
+Build-Depends-Indep: halibut,
 Homepage: https://www.chiark.greenend.org.uk/~sgtatham/putty/
 Vcs-Git: https://salsa.debian.org/ssh-team/putty.git
 Vcs-Browser: https://salsa.debian.org/ssh-team/putty

=== debian/rules ===
#! /usr/bin/make -f
%:
	dh $@ -Bdebian/build

ptermtmp = debian/pterm

export DEB_BUILD_MAINT_OPTIONS := hardening=+all
export DEB_CPPFLAGS_MAINT_APPEND := -D_FILE_OFFSET_BITS=64

include /usr/share/dpkg/default.mk

execute_after_dh_auto_build-arch:
	$(MAKE) -C icons cicons pngs

override_dh_auto_build-indep:
	if [ ! -e debian/version.but.save ]; then \
		cp -a doc/version.but debian/version.but.save; \
	fi
	printf '\\versionid %s PuTTY release %s\n' \
		"$(DEB_VENDOR)" "$(DEB_VERSION)" >doc/version.but
	$(MAKE) -C debian/build doc

execute_after_dh_auto_clean:
	$(MAKE) -C icons clean
	if [ -e debian/version.but.save ]; then \
		mv debian/version.but.save doc/version.but; \
	fi

override_dh_auto_install-indep:

override_dh_installdocs:
	dh_installdocs -Nputty-doc
	dh_installdocs -pputty-doc \
		--sourcedir=debian/build --doc-main-package=putty-doc

override_dh_compress:
	dh_compress -X.py

execute_after_dh_fixperms-arch:
	chgrp utmp $(ptermtmp)/usr/bin/pterm
	chmod g+s $(ptermtmp)/usr/bin/pterm
